'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AlertList = exports.Alert = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Alert = exports.Alert = function (_Component) {
    _inherits(Alert, _Component);

    function Alert() {
        _classCallCheck(this, Alert);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(Alert).apply(this, arguments));
    }

    _createClass(Alert, [{
        key: 'getInterjection',
        value: function getInterjection() {
            switch (this.props.type) {
                case 'success':
                    return 'Well Done!';
                case 'info':
                    return 'Heads Up!';
                case 'warning':
                    return 'Warning!';
                case 'danger':
                    return 'Oh Snap!';
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var className = 'alert alert-' + this.props.type;

            return _react2.default.createElement(
                'div',
                { className: className, role: 'alert' },
                _react2.default.createElement(
                    'strong',
                    null,
                    this.getInterjection()
                ),
                ' ',
                this.props.children
            );
        }
    }]);

    return Alert;
}(_react.Component);

Alert.defaultProps = {
    type: 'danger'
};

var AlertList = exports.AlertList = function (_Component2) {
    _inherits(AlertList, _Component2);

    function AlertList() {
        _classCallCheck(this, AlertList);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(AlertList).apply(this, arguments));
    }

    _createClass(AlertList, [{
        key: 'render',
        value: function render() {
            var _this3 = this;

            return _react2.default.createElement(
                'div',
                null,
                this.props.errors.map(function (error, index) {
                    return _react2.default.createElement(
                        Alert,
                        { key: index, type: _this3.props.type },
                        error
                    );
                })
            );
        }
    }]);

    return AlertList;
}(_react.Component);

AlertList.defaultProps = {
    type: 'danger',
    errors: []
};