'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO REFACTOR this, text, and password components.

var _class = function (_Component) {
    _inherits(_class, _Component);

    function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(_class).apply(this, arguments));
    }

    _createClass(_class, [{
        key: 'getKey',
        value: function getKey() {
            return this.props.key || this.props.label.toLowerCase().replace(/\W+/g, '-');
        }
    }, {
        key: 'getClassName',
        value: function getClassName() {
            var className = "form-group";

            if (_typeof(this.props.errors) === 'object' && this.props.errors.length) {
                className += ' has-danger';
            }

            return className;
        }
    }, {
        key: 'getInputClassName',
        value: function getInputClassName() {
            var className = "form-control c-select";

            if (_typeof(this.props.errors) === 'object' && this.props.errors.length) {
                className += ' form-control-danger';
            }

            return className;
        }
    }, {
        key: 'getErrors',
        value: function getErrors() {
            return _react2.default.createElement(
                'div',
                null,
                this.props.errors.map(function (error, index) {
                    return _react2.default.createElement(
                        'small',
                        { key: index, className: 'text-muted text-help' },
                        error
                    );
                })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'fieldset',
                { className: this.getClassName() },
                _react2.default.createElement(
                    'label',
                    { className: 'form-control-label', htmlFor: this.getKey() },
                    this.props.label
                ),
                _react2.default.createElement(
                    'select',
                    { defaultValue: this.props.defaultValue, className: this.getInputClassName(), id: this.getKey(), ref: this.props.refLink },
                    this.props.children
                ),
                this.props.errors ? this.getErrors() : null
            );
        }
    }]);

    return _class;
}(_react.Component);

_class.defaultProps = {
    errors: [],
    label: '',
    autoFocus: false,
    defaultValue: null
};
exports.default = _class;